; Sound for the wall
; copyright (C) W. Lenerz 2000-2016, see the accompanying licence_txt file.

	section sound
	xdef	sound

; sound routine for the poor ql hard(?)ware
; on entry: d0 = 0 if no connections found
;	    d0 = 1 if connections found
;	    d0 = 2 if game over - lost
;	    d0 = 3 if game over - won
;	    d0 = 4 plus item clicked
;	    d0 = 5 minus item
; v. 1.01

myregs	reg	d1/d5/d7/a3

sound	movem.l myregs,-(a7)
	lea	sound_blk,a3
	lsl.w	#2,d0
	add.w	d0,a3
	add.l	(a3),a3
bp2	moveq	#$11,d0
	trap	#1
ret	movem.l (a7)+,myregs
	moveq	#0,d0
	rts
	
none_fnd
	DC.b	$0a,$08 	; sound with 8 params
	dc.l	$aaaa
	DC.b	$fb,0		; pitch 1& 2
	DC.B	0,0		; grad x = interval between steps
	DC.B	$b8,$b		; duration
	DC.B	0		; grad y
	dc.l	0		; remaining params ignored
				  
fnd_one DC.b	$0a,$08 	; sound with 8 params
	dc.l	$aaaa
	DC.B	1		; pitch 1
	dc.B	200		; pitch 2: 200
	DC.B	40,0		; grad x : time between pitch steps
	DC.b	$4c,$1d 	; duration: lsb first! = $1d4c = 7500
	DC.B	$70		; grad y , only nibble of first byte is taken into account
	dc.l	0		; remaining params ignored

game_over
		 
	DC.b	$0a,$08 	; sound with 8 params
	dc.l	$aaaa
	dc.b	11,251		; pitch 1 & 2
	dc.b	$e8,3		; grad x (1000)
	dc.b	$20,$4e 	; duration
	dc.b	$50		; grad y
	dc.l	0
won_game
	DC.b	$0a,$08 	; sound with 8 params
	dc.l	$aaaa
	DC.B	71,2
	DC.B	$e8,3		; grad x
	DC.B	$C8,$32 	; duration, lsb first
	DC.B	$50
	dc.l	0

plus
	DC.b	$0a,$08 	; sound with 8 params
	dc.l	$aaaa
	DC.B	140,0
	DC.B	0,0		; grad x
	DC.B	0,2		; duration, lsb first
	DC.B	$00
	dc.l	0
	
minus
	DC.b	$0a,$08 	; sound with 8 params
	dc.l	$aaaa
	DC.B	240,0
	DC.B	0,0		; grad x
	DC.B	0,2		; duration, lsb first
	DC.B	$00
	dc.l	0
	       
sound_blk
	dc.l	none_fnd-*
	dc.l	fnd_one-*
	dc.l	game_over-*
	dc.l	won_game-*
	dc.l	plus-*
	dc.l	minus-*

	end
